const C3 = self.C3;

C3.Behaviors.FedericoCalchera_HP.Instance = class HPInstance extends C3.SDKBehaviorInstanceBase
{
    constructor(behInst, properties)
    {
        super(behInst);

        this.amountHealed = 0;
        this.damageTaken = 0;
        this.healingAmount = 0;
        this.damageAmount = 0;
        this.newHP = 0;
        this.bounds = {};
        this.lastBoundTag = "";
        this.lastBoundValue = 0;
        if (properties)
        {
            this.HP = properties[0];
            this.maxHP = properties[0];
            this.isEnabled = properties[1];
        }

        this._StartTicking();
    }

    Tick()
    {

        this.Trigger(C3.Behaviors.FedericoCalchera_HP.Cnds.Onanychange);
        this._StopTicking()
    }


    Release()
    {
        super.Release();
    }

    _Damage(amount)
    {
        if (!this.isEnabled) return;

        this.newHP = Math.max(this.HP - amount, 0);
        //this.newHP = this._checkAnyBoundReached(this.newHP);
        this.damageTaken = this.HP - this.newHP;
        this.damageAmount = amount;
        this.HP = this.newHP;
        this.Trigger(C3.Behaviors.FedericoCalchera_HP.Cnds.Onanychange);
        this.Trigger(self.C3.Behaviors.FedericoCalchera_HP.Cnds.Hplost);
        if (this.HP === 0) this.Trigger(self.C3.Behaviors.FedericoCalchera_HP.Cnds.OnHpReachedZero);
    }

    _Heal(amount)
    {
        if (!this.isEnabled) return;

        this.newHP = Math.min(this.HP + amount, this.maxHP);
        this.amountHealed = this.newHP - this.HP;
        this.healingAmount = amount;
        this.HP = this.newHP;
        this.Trigger(C3.Behaviors.FedericoCalchera_HP.Cnds.Onanychange);
        this.Trigger(C3.Behaviors.FedericoCalchera_HP.Cnds.Hpincreased);
    }

    _SetIsEnabled(n)
    {
        this.isEnabled = n
    }


    _GetIsEnabled()
    {
        return this.isEnabled
    }

    _GetHealingAmount()
    {
        return this.healingAmount
    }

    _GetHealingReceived()
    {
        return this.healingReceived
    }

    _GetDamageAmount()
    {
        return this.damageAmount
    }

    _GetDamageReceived()
    {
        return this.damageTaken
    }

    _SetHP(n)
    {
        if (!this.isEnabled) return;

        this.HP = Math.min(Math.max(n, 0), this.maxHP);
        this.Trigger(C3.Behaviors.FedericoCalchera_HP.Cnds.Onanychange);
    }

    _GetHP()
    {
        return this.HP
    }

    _SetMax(n)
    {
        if (this.isEnabled)
        {
            this.maxHP = Math.max(n, 0);
            this.HP = Math.min(this.HP, this.maxHP);
            this.Trigger(C3.Behaviors.FedericoCalchera_HP.Cnds.Onanychange);
        }
    }

    _GetMax()
    {
        return this.maxHP
    }

    _GetNormalizedHP()
    {
        return (this.HP / this.maxHP)
    }

    //bounds

    /*_addBound(tag, threshold)
    {
        this.bounds[tag] = threshold;
    }

    _GetBound(tag)
    {
        console.log(this.bounds[tag])
        if (this.bounds[tag] == null) return 0;
        return this.bounds[tag];
    }


    _removeBound(tag)
    {
        delete this.bounds[tag];
    }

    _checkAnyBoundReached(targetHP)
    {
        let greatestBound = targetHP;
        let boundFound = false;

        for (const[key, value] of Object.entries(this.bounds))
        {
            if (value >= greatestBound)
            {
                greatestBound = value;
                this.lastBoundTag = key;
                this.lastBoundValue = value;
                boundFound = true;
            }
        }
        if (boundFound) this.Trigger(C3.Behaviors.FedericoCalchera_HP.Cnds.Onboundreached);
        return greatestBound;
    }*/

    SaveToJson()
    {
        return {
            "HP": this.HP,
            "maxHP": this.maxHP,
            "isEnabled": this.isEnabled,
            "bounds": this.bounds,
            "lastBoundTag": this.lastBoundTag,
            "lastBoundValue": this.lastBoundValue
        };
    }

    LoadFromJson(o)
    {
        this.HP = o.HP;
        this.maxHP = o.maxHP;
        this.isEnabled = o.isEnabled;
        this.bounds = o.bounds;
        this.lastBoundTag = o.lastBoundTag;
        this.lastBoundValue = o.lastBoundValue;
    }


    GetDebuggerProperties()
    {
        return [
        {
            title: "$HP",
            properties: [
            {
                name: "$Max",
                value: this.maxHP,
                onedit: v => this._SetMax(v)},
            {
                name: "$Current",
                value: this.HP,
                onedit: v => this._SetHP(v)},

            {
                name: "$Enabled",
                value: this.isEnabled,
                onedit: v => this._SetIsEnabled(v)}

            ]
        }];
    }

    // timeline support
    GetPropertyValueByIndex(index)
    {
        return 0;
    }

    SetPropertyValueByIndex(index, value)
    {
        //set property value here
    }

    GetScriptInterfaceClass()
    {
        return self.IMyBehaviorInstance;
    }
};

// Script interface for behavior instance
const map = new WeakMap();

self.IMyBehaviorInstance = class IMyBehaviorInstance extends self.IBehaviorInstance
{
    constructor()
    {
        super();

        // Map by SDK instance
        map.set(this, self.IBehaviorInstance._GetInitInst().GetSdkInstance());
    }

    // Example setter/getter property on script interface
    set Current(n)
    {
        map.get(this)._SetHP(n);
    }

    get Current()
    {
        return map.get(this)._GetHP();
    }

    set Max(n)
    {
        map.get(this)._SetMax(n);
    }

    get Max()
    {
        return map.get(this)._GetMax();
    }

    set isEnabled(n)
    {
        map.get(this)._SetIsEnabled(n);
    }

    get isEnabled()
    {
        return map.get(this)._GetIsEnabled();
    }

    get NormalizedCurrent()
    {
        return map.get(this)._GetNormalizedHP();
    }

    get DamageAmount()
    {
        return map.get(this)._GetDamageAmount();
    }

    get DamageReceived()
    {
        return map.get(this)._GetDamageReceived();
    }

    get HealingAmount()
    {
        return map.get(this)._GetHealingAmount();
    }

    get HealingReceived()
    {
        return map.get(this)._GetHealingReceived();
    }

    Damage(amount)
    {
        map.get(this)._Damage(amount);
    }

    Heal(amount)
    {
        map.get(this)._Heal(amount);
    }

};